"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isVarargConstantNode = exports.isGlobalVarargConstant = void 0;
const extensions = require("../../utils/language-extensions");
const scope_1 = require("../../utils/scope");
function isGlobalVarargConstant(context, symbol, scope) {
    return (scope.type === scope_1.ScopeType.File &&
        extensions.isExtensionValue(context, symbol, extensions.ExtensionKind.VarargConstant));
}
exports.isGlobalVarargConstant = isGlobalVarargConstant;
function isVarargConstantNode(context, node) {
    const symbol = context.checker.getSymbolAtLocation(node);
    return symbol ? extensions.isExtensionValue(context, symbol, extensions.ExtensionKind.VarargConstant) : false;
}
exports.isVarargConstantNode = isVarargConstantNode;
//# sourceMappingURL=vararg.js.map